<?php

// +---------------------------------------------------------------------------+
// | phpblock_mt2geeklog.php  ver 0.1.2 for Geeklog 1.4.0                      |
// +---------------------------------------------------------------------------+
// | Copyright (C) 2006 by the following authors:                              |
// |                                                                           |
// |  Author: mystral_kk - mystra_kk AT ddlinks DOT net                        |
// +---------------------------------------------------------------------------+
// |                                                                           |
// | This program is free software; you can redistribute it and/or             |
// | modify it under the terms of the GNU General Public License               |
// | as published by the Free Software Foundation; either version 2            |
// | of the License, or (at your option) any later version.                    |
// |                                                                           |
// | This program is distributed in the hope that it will be useful,           |
// | but WITHOUT ANY WARRANTY; without even the implied warranty of            |
// | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the             |
// | GNU General Public License for more details.                              |
// |                                                                           |
// | You should have received a copy of the GNU General Public License         |
// | along with this program; if not, write to the Free Software Foundation,   |
// | Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.           |
// |                                                                           |
// +---------------------------------------------------------------------------+
//
// $Id$

// Import stories (*.log file) from Movable Type(R)
//
// Reference: http://www.sixapart.com/movabletype/docs/3.2/f_import_format/
//
// Notice:
//   1. NO ENTRY keys (import only comments) are not supported.  Keys which are
//     not defined in the above web page will be igonored.
//   2. If a story has no TITLE key, its title will be "NO TITLE".
//   3. EXCERPT keys are not supported.
//   4. When no PRIMARY CATEGORY key is found but more than one CATEGORY key is
//     found, the CATEGORY key which appears LAST will be adopted as the title.
//   5. when ALLOW COMMENTS key and/or ALLOW PINGS keys have values other than 0,
//     it will be converted to -1.

// Constants related to MT import file format.  You shouldn't have to change these.
define('ARTICLE_SEPARATOR', "--------\n");  // Standard artcile separator
define('FIELD_SEPARATOR', "-----\n");       // Standard field separator
define('META_SEPARATOR', "\n");             // Standard separator within META section
define('ML_SEPARATOR', "\n");               // Multiline separator in the BODY,
                                            //   EXTENDED BOY, EXCERPT, COMMENTS
                                            //   section

// You can change these two values if necessary.
define('BR_LINE', '<br>');                  // "\n" in multiline sections will be
                                            //   coverted to this tag.  In case of
                                            //   XHTML, use <br /> instead.
define('MAX_FILE_SIZE', 2000000);           // Max size of a file you can upload.

//define('DEBUG', 1);                       // uncomment this line to debug this script

// Messages dependent on your language.  Be careful with heredoc identifier
// ("EOD_LanguageNameNum") when you add your own langauge below.

$LANG_MT2GEEKLOG = array();

// English

$LANG_MT2GEEKLOG['english']['setting1'] = <<<EOD_english1
<form name="importform" enctype="multipart/form-data" action="{$_SERVER['PHP_SELF']}" method="post">
  <p><input type="hidden" name="MAX_FILE_SIZE" value="
EOD_english1;
$LANG_MT2GEEKLOG['english']['setting1'] .= MAX_FILE_SIZE . '">Import File:<input name="importfile" type="file"></p>';

$LANG_MT2GEEKLOG['english']['setting2'] = <<<EOD_english2
    <p>Input Encoding:<br>
    <select name="encoding">
        <option value="AUTO" selected="selected">Auto</option>
        <option value="ASCII">ASCII</option>
        <option value="eucJP-win">eucJP-win</option>
        <option value="EUC-JP">EUC-JP</option>
        <option value="UTF-8">UTF-8</option>
        <option value="SJIS-win">SJIS-win</option>
        <option value="SJIS">SJIS</option>
        <option value="JIS">JIS</option>
        <option value="ISO-2022-JP">ISO-2022-JP</option>
        <option value="UTF-7">UTF-7</option>
    </select></p>
EOD_english2;

$LANG_MT2GEEKLOG['english']['setting3'] = <<<EOD_english3
    <p>Story Owner:<br>
    <select name="author">
        <option value="au_astheyare" selected>Original Author</option>
        <option value="au_astheyare_possible">Original Author Possible</option>
        <option value="au_asmyself">Admin</option>
    </select></p>
    <p>Default Topic:<br>
    <input name="default_category" type="text" title="IMPORTED-FROM-MT" value="IMPORTED-FROM-MT"></p>
    <p>Submit Status:<br>
    <select name="submit_status">
        <option value="ss_astheyare" selected>As they are</option>
        <option value="ss_force_post">All submitted</option>
        <option value="ss_force_draft">All draft</option>
    </select></p>
    <p>Comments:<br>
    <select name="handle_comment">
        <option value="hc_yes" selected>Import</option>
        <option value="hc_no">Don't import</option>
    </select></p>
    <p>Allow Comments:<br>
    <select name="allow_comment">
        <option value="ac_auto" selected>Auto</option>
        <option value="ac_astheyare">As they are</option>
        <option value="ac_force_enabled">Enable all</option>
        <option value="ac_force_disabled">Disable all</option>
    </select><br>
    <p>Trackbacks:<br>
    <select name="handle_tb">
        <option value="ht_yes">Import</option>
        <option value="ht_no" selected>Don't import</option>
    </select><br>
    <p>Allow Trackbacks:<br>
    <select name="allow_tb">
        <option value="at_auto" selected>Auto</option>
        <option value="at_astheyare">As they are</option>
        <option value="at_force_enabled">Enable all</option>
        <option value="at_force_disabled">Diable all</option>
    </select><br>
    <p>Start title HTML:<br>
    <input name="start_title_html" type="text"></p>
    <p>End title HTML:<br>
    <input name="end_title_html" type="text"></p>
    <p>Post mode:<br>
    <select name="text_type">
        <option value="plaintext">plaintext</option>
        <option value="html" selected>HTML</option>
    </select><br><br>
    <input type="hidden" name="cmd" value="import">
    <input type="submit" name="submit" value="Import!">
</form>
EOD_english3;

$LANG_MT2GEEKLOG['english']['cannotupload'] = 'Cannot upload the designated file.';
$LANG_MT2GEEKLOG['english']['cannotopen']   = 'Cannot open the uploaded file.';
$LANG_MT2GEEKLOG['english']['failure']      = 'Failure';
$LANG_MT2GEEKLOG['english']['num_data']     = 'Number of data';
$LANG_MT2GEEKLOG['english']['success']      = 'Success';

// Japanese

$LANG_MT2GEEKLOG['japanese']['setting1'] = <<<EOD_japanese1
<form name="importform" enctype="multipart/form-data" action="{$_SERVER['PHP_SELF']}" method="post">
  <p><input type="hidden" name="MAX_FILE_SIZE" value="
EOD_japanese1;
$LANG_MT2GEEKLOG['japanese']['setting1'] .= MAX_FILE_SIZE . '">インポートするファイル名: <input name="importfile" type="file"></p>';

$LANG_MT2GEEKLOG['japanese']['setting2'] = <<<EOD_japanese2
    <p>入力エンコーディング：<br>
    <select name="encoding">
        <option value="AUTO" selected="selected">自動判別</option>
        <option value="ASCII">ASCII</option>
        <option value="eucJP-win">eucJP-win</option>
        <option value="EUC-JP">EUC-JP</option>
        <option value="UTF-8">UTF-8</option>
        <option value="SJIS-win">SJIS-win</option>
        <option value="SJIS">SJIS</option>
        <option value="JIS">JIS</option>
        <option value="ISO-2022-JP">ISO-2022-JP</option>
        <option value="UTF-7">UTF-7</option>
    </select></p>
EOD_japanese2;

$LANG_MT2GEEKLOG['japanese']['setting3'] = <<<EOD_japanese3
    <p>記事のオーナー：<br>
    <select name="author">
        <option value="au_astheyare" selected>すべて元の投稿者</option>
        <option value="au_astheyare_possible">できるだけ元の投稿者</option>
        <option value="au_asmyself">Admin</option>
    </select></p>
    <p>デフォルトの話題：<br>
    <input name="default_category" type="text" title="IMPORTED-FROM-MT" value="IMPORTED-FROM-MT"></p>
    <p>投稿状態：<br>
    <select name="submit_status">
        <option value="ss_astheyare" selected>元のデータ通り</option>
        <option value="ss_force_post">すべて投稿済みにする</option>
        <option value="ss_force_draft">すべて下書きにする</option>
    </select></p>
    <p>コメント：<br>
    <select name="handle_comment">
        <option value="hc_yes" selected>インポートする</option>
        <option value="hc_no">インポートしない</option>
    </select></p>
    <p>コメント許可：<br>
    <select name="allow_comment">
        <option value="ac_auto" selected>自動判別</option>
        <option value="ac_astheyare">元のデータ通り</option>
        <option value="ac_force_enabled">すべて許可する</option>
        <option value="ac_force_disabled">すべて禁止する</option>
    </select><br>
    <p>トラックバック：<br>
    <select name="handle_tb">
        <option value="ht_yes">インポートする</option>
        <option value="ht_no" selected>インポートしない</option>
    </select><br>
    <p>トラックバック許可：<br>
    <select name="allow_tb">
        <option value="at_auto" selected>自動判別</option>
        <option value="at_astheyare">元のデータ通り</option>
        <option value="at_force_enabled">すべて許可する</option>
        <option value="at_force_disabled">すべて禁止する</option>
    </select><br>
    <p>Start title HTML:<br>
    <input name="start_title_html" type="text"></p>
    <p>End title HTML:<br>
    <input name="end_title_html" type="text"></p>
    <p>投稿モード：<br>
    <select name="text_type">
        <option value="plaintext">テキスト</option>
        <option value="html" selected>HTML形式</option>
    </select><br><br>
    <input type="hidden" name="cmd" value="import">
    <input type="submit" name="submit" value="インポート">
</form>
EOD_japanese3;

$LANG_MT2GEEKLOG['japanese']['cannotupload'] = 'ファイルをアップロードできません。';
$LANG_MT2GEEKLOG['japanese']['cannotopen']   = 'アップロードされたファイルを開けません。';
$LANG_MT2GEEKLOG['japanese']['failure']      = '失敗';
$LANG_MT2GEEKLOG['japanese']['num_data']     = 'データ数';
$LANG_MT2GEEKLOG['japanese']['success']      = '成功';

//===================================================================
//  MAIN FUNCTION
// ==================================================================

function phpblock_mt2geeklog() {

    global $_CONF, $_TABLES, $_USER, $LANG_CHARSET, $LANG_MT2GEEKLOG;
    
    if (!SEC_inGroup ('Root')) {
        return "";
    }
    
    require_once ($_CONF['path_system'] . 'lib-user.php');
    require_once ($_CONF['path_system'] . 'classes/upload.class.php');
    
    // Constants cant't have an array, so we have to define here
    $META_KEYS    = array('AUTHOR', 'TITLE', 'DATE', 'PRIMARY CATEGORY', 'CATEGORY',
        'STATUS', 'ALLOW COMMENTS', 'ALLOW PINGS', 'CONVERT BREAKS', 'NO ENTRY');
    $MAIN_KEYS    = array('BODY', 'EXTENDED BODY', 'EXCERPT', 'COMMENT', 'PING');
    $COMMENT_KEYS = array('AUTHOR', 'EMAIL', 'URL', 'IP', 'DATE');
    $PING_KEYS    = array('TITLE', 'URL', 'IP', 'BLOG NAME', 'DATE');
    
	// Can we use mbstring (mutibyte string) functions?
	$hasMbstring = (function_exists('mb_detect_encoding')
		&& function_exists('mb_convert_encoding'));

    // Decides which language to display
    $LANG = $_USER['language'];
    if (empty($LANG)) {
        $LANG = $_CONF['language'];
    }
    if (empty($LANG)) {
        $LANG = 'english';
    }
    $LANG = strtolower($LANG);
    
    if (($p = strpos($LANG, '_utf-8')) > 0) {
        $LANG = substr($LANG, 0, $p);
    }
    if (! isset($LANG_MT2GEEKLOG[$LANG])) {
        $LANG = 'english';
    }

    // Geeklog version prior to 1.4.0 didn't have trackback features.  Let's check here.
	$hasTrackback = false;
	if (defined('VERSION')) {
		$v = explode('.', VERSION);
		if ($v[0] == 1 && $v[1] >= 4) {
			$hasTrackback = true;
		}
	}
	
    if (! isset($_POST['submit']) || ! isset($_POST['cmd'])
     || $_POST['cmd'] != 'import') {
	 	if ($hasMbstring) {
	        return $LANG_MT2GEEKLOG[$LANG]['setting1']
			  . $LANG_MT2GEEKLOG[$LANG]['setting2'] . $LANG_MT2GEEKLOG[$LANG]['setting3'];
		} else {
	        return $LANG_MT2GEEKLOG[$LANG]['setting1']
			  . $LANG_MT2GEEKLOG[$LANG]['setting3'];
		}
    }

// ----------------------------------------------------------------------------
//  IMPORT MAIN
// ----------------------------------------------------------------------------

    $retval = '';

    // Get options
    $op_encoding         = COM_applyFilter($_POST['encoding']);
    $op_author           = COM_applyFilter($_POST['author']);
    $op_default_category = strip_tags(trim($_POST['default_category']));
    if ($op_default_category == '') {
        $op_default_category = 'IMPORTED-FROM-MT';
    }
    $op_submit_status    = COM_applyFilter($_POST['submit_status']);
    $op_handle_comment   = (COM_applyFilter($_POST['handle_comment']) == 'hc_yes');
    $op_allow_comment    = COM_applyFilter($_POST['allow_comment']);
    $op_handle_tb        = (COM_applyFilter($_POST['handle_tb']) == 'ht_yes');
    $op_allow_tb         = COM_applyFilter($_POST['allow_tb']);
    $op_start_title_html = trim($_POST['start_title_html']);
    $op_end_title_html   = trim($_POST['end_title_html']);
    $op_text_type        = COM_applyFilter($_POST['text_type']);
    
    // Upload a file to import.  Code borrowed from Geeklog's /admin/user.php
    $upload = new upload ();
    $upload->setPath ($_CONF['path_data']);
    $upload->setAllowedMimeTypes (array ('text/plain' => '.log'));
    $upload->setFileNames ('mt_import_file.log');
    if ($upload->uploadFiles ()) {
        // Good, file got uploaded, now install everything
        $thefile =  current ($_FILES);
        $filename = $_CONF['path_data'] . 'mt_import_file.log';
    } else {
        // A problem occurred, print debug information
        return $LANG_MT2GEEKLOG[$LANG]['cannotupload'];
    }

    $f = file_get_contents($filename);
    if ($f === false) {
        return $LANG_MT2GEEKLOG[$LANG]['cannotopen'];
    } else {
        unlink($filename);
    }

	// If we have loaded mbstring (multibyte string) functions, we can convert encodings
	if ($hasMbstring) {
	    // Get the internal encoding your Geeklog is using
    	COM_errorLog("phpblock_mt2geeklog: Conversion started.");
    	if (isset($LANG_CHARSET)) {
        	$internal_encoding = $LANG_CHARSET;
	    } else if (isset($_CONF['default_charset'])) {
    	    $internal_encoding = $_CONF['default_charset'];
    	} else {
        	$internal_encoding = 'iso-8859-1';
    	}

	    // Get the encoding of the imported file, if necessary
    	if ($op_encoding == 'AUTO') {
        	$op_encoding = mb_detect_encoding($f, "ASCII,JIS,UTF-8,eucJP-win,EUC-JP,SJIS-win,SJIS");
    	}
    	COM_errorLog("phpblock_mt2geeklog: Encoding conversion: {$op_encoding} --> {$internal_encoding}");
    	$f = mb_convert_encoding($f, $internal_encoding, $op_encoding);
	} else {
    	COM_errorLog("phpblock_mt2geeklog: Mbstring (multibyte-string) functions are unavailable.  There is no converting encodings.");
	}
    
    // Change all carriage-return and line-feed chars into "\n"
   	$f = trim($f);
    $f = str_replace(array("\r\n", "\r"), "\n", $f);
    
    // Split the content into stories
    $mt_articles = explode(ARTICLE_SEPARATOR, $f);
    $num_good = $num_bad = 0;

    // Parse a story
    foreach ($mt_articles as $mt_article) {
        // Split a story into fields
        $fields = explode(FIELD_SEPARATOR, $mt_article);

        // The first field should be META data of the story
        unset($article);
        $article['META'] = parseMetadata($fields[0], $META_KEYS);

        // Multiline data should follow ffrom here on
        for ($i = 1; $i < count($fields); $i ++) {
            // Split a multiline field into sub-fields
            $sub_fields = explode(ML_SEPARATOR, $fields[$i]);
            if (getKeyAndValue($sub_fields[0], $MAIN_KEYS, $key, $val)) {
                switch ($key) {
                    case 'BODY':
                    case 'EXTENDED BODY':
                        $article[$key] = implode(ML_SEPARATOR, array_slice($sub_fields, 1));
                        break;
                    case 'COMMENT':
                        $comment = array();
                        for ($j = 1; $j < count($sub_fields); $j ++) {
                            if (getKeyAndValue($sub_fields[$j], $COMMENT_KEYS, $subkey, $subval)) {
                                $comment[$subkey] = $subval;
                            } else {  // Cooment body
                                $comment['BODY']  = implode(ML_SEPARATOR, array_slice($sub_fields, $j));
                                break;  // break for-next loop
                            }
                        }
                        $article['COMMENTS'][] = $comment;
                        break;
                    case 'PING':    // Trackbacks
                        $ping = array();
                        for ($j = 1; $j < count($sub_fields); $j ++) {
                            if (getKeyAndValue($sub_fields[$j], $PING_KEYS, $subkey, $subval)) {
                                $ping[$subkey] = $subval;
                            } else {  // Trackback body
                                $ping['BODY']  = implode(ML_SEPARATOR, array_slice($sub_fields, $j));
                                break;  // break for-next loop
                            }
                        }
                        $article['PINGS'][] = $ping;
                        break;

                    // All keys other than standard keys are ignored.  Besides, 
                    // mt2geeklog igonres "EXCERPT" keys and "NO ENTRY" keys.
                    default:
                        break;
                }
            }
        }  // end of for-next loop
        // Parse finshed.  Here, the whole story data are stored in $article.
        
        // Cook parsed data so they can be stored in the databse
        
        // Story ID
        $sid = getUniquesid();
        
        // User ID
        if ($op_author == 'au_asmyself') {
            $uid = $_USER['uid'];
        } else {
            $uid = getAuthorId($article['META']['AUTHOR'], $op_author);
        }

        // Draft_flag -- the same as in Movable Type(0 = Publish  1 = Draft)
        $draft_flag = intval(COM_applyFilter($article['META']['STATUS']));
        if ($op_submit_status == 'ss_force_post') {
            $draft_flag = 0;
        } else if ($op_submit_status == 'ss_force_draft') {
            $draft_flag = 1;
        }
        
        // Topic ID
        $tid = getTopicId(
            $article['META']['PRIMARY CATEGORY'],
            $article['META']['CATEGORY'],
            $op_default_category
        );
        $tid = addslashes($tid);
        
        // Date
        $unixdate = $article['META']['DATE'];
        if ($unixdate == '') {  // This will be unnecessary
            $unixdate = '0000-00-00 00:00:00';
        }
        
        // Title
        $title = strip_tags($article['META']['TITLE']);
        if ($title == '') {
            $title = 'NO TITLE';
            if ($op_start_title_html != '' && $op_end_title_html != '') {
                $title = getTitleFromBody(
                    $article['BODY'], $op_start_title_html, $op_end_title_html
                );
                $title = trim($title);
                if ($title != '') {
                    $title = strip_tags($title);
                } else {
                    $title ='NO TITLE';
                }
            }
        }
        $title = addslashes($title);

        // IntroText, BodyText
        $cnv_br    = COM_applyFilter($article['META']['CONVERT BREAKS']);
        $introtext = addslashes(renderBody($article['BODY'], $op_text_type, $cnv_br));
        $bodytext  = addslashes(renderBody($article['EXTENDED BODY'], $op_text_type, $cnv_br));

        // Comments
        $comments = 0;
        if ($op_handle_comment) {
            for ($i = 0; $i < count($article['COMMENTS']); $i ++) {
                if (do_comment($sid, $article['COMMENTS'][$i], $op_text_type, $cnv_br)) {
                    $comments ++;
                }
            }
        }
        
        // Trackbacks
        $trackbacks = 0;
        if ($op_handle_tb) {
            for ($i = 0; $i < count($article['PINGS']); $i ++) {
                if (do_trackback($sid, $article['PINGS'][$i], $op_text_type, $cnv_br)) {
                    $trackbacks ++;
                }
            }
        }
        
        // Commentcode
        //
        // Convert MT values (0, 1) to Geeklog values (0, -1).  Values other than 0
        // will be converted to -1.
        $allow_comments = intval(COM_applyFilter($article['META']['ALLOW COMMENTS']));
        if ($allow_comments == 0) {
            $commentcode = 0;
        } else {
            $commentcode = -1;
        }
        
        // When a story has some comments but disables them, imported comments
        // will not be displayed.  This might be inconvenient for some users
        // including myself, so let users choose what to do with them.
        switch ($op_allow_comment) {
            case 'ac_astheyare':        // Will be imported as they are
                break;
            case 'ac_auto':             // The same as above, but allows comments
                if ($comments > 0) {    // if there are any comments.
                    $commentcode = 0;
                }
                break;
            case 'ac_force_enabled':    // Enables all comments
                $commentcode = 0;
                break;
            case 'ac_force_disabled':   // Disbles all comments
                $commentcode = -1;
                break;
        }
        
        // Trackbackcode
        //
        // Convert MT values (0, 1) to Geeklog values (0, -1).  Values other than 0
        // will be converted to -1.
        $allow_tb = intval(COM_applyFilter($article['META']['ALLOW PINGS']));
        if ($allow_tb == 0) {
            $trackbackcode = 0;
        } else {
            $trackbackcode = -1;
        }

        // When a story has some trackbacks but disables them, imported trackbacks
        // will not be displayed.  This might be inconvenient for some users
        // including myself, so let users choose what to do with them.
        switch ($op_allow_tb) {
            case 'at_astheyare':        // Will be imported as they are
                break;
            case 'at_auto':             // The same as above, but allows trackbacks
                if ($trackbacks > 0) {  // if there are any trackbacks.
                    $trackbackcode = 0;
                }
                break;
            case 'at_force_enabled':    // Enables all trackbacks
                $trackbackcode = 0;
                break;
            case 'at_force_disabled':   // Disables all trackbacks
                $trackbackcode = -1;
                break;
        }
        
		$expire   = '0000-00-00 00:00:00';	// dummy
        $postmode = $op_text_type;
        $owner_id = $uid;
        $group_id = 3;      // Story Admin
        
        if (defined('DEBUG')) {
            COM_errorLog("phpblock_mt2geeklog: (DEBUG) query = " . "INSERT INTO {$_TABLES['stories']} (sid, uid, draft_flag, tid, date, title, introtext, bodytext, comments, trackbacks, commentcode, trackbackcode, expire, postmode, owner_id, group_id) VALUES ('$sid', $uid, $draft_flag, '$tid', '$unixdate', '$title', '$introtext', '$bodytext', $comments, $trackbacks, $commentcode, $trackbackcode, '$expire', '$postmode', $owner_id, $group_id);");
        } else {
			if ($hasTrackback) {
	            DB_query ("INSERT INTO {$_TABLES['stories']} (sid, uid, draft_flag, tid, date, title, introtext, bodytext, comments, trackbacks, commentcode, trackbackcode, expire, postmode, owner_id, group_id) VALUES ('$sid', $uid, $draft_flag, '$tid', '$unixdate', '$title', '$introtext', '$bodytext', $comments, $trackbacks, $commentcode, $trackbackcode, '$expire', '$postmode', $owner_id, $group_id);");
			} else {
	            DB_query ("INSERT INTO {$_TABLES['stories']} (sid, uid, draft_flag, tid, date, title, introtext, bodytext, comments, commentcode, expire, postmode, owner_id, group_id) VALUES ('$sid', $uid, $draft_flag, '$tid', '$unixdate', '$title', '$introtext', '$bodytext', $comments, $commentcode, '$expire', '$postmode', $owner_id, $group_id);");
			}
            $rst = DB_error();
            if ($rst == '') {
                $num_good ++;
            } else {
                $num_bad ++;
                COM_errorLog("phpblock_mt2geeklog: $rst");
            }
        }
    }

    COM_errorLog("phpblock_mt2geeklog: Import finished.  Success: {$num_good}, Failure: {$num_bad}");
    return "{$LANG_MT2GEEKLOG[$LANG]['num_data']}: {$num_total}<br>{$LANG_MT2GEEKLOG[$LANG]['success']}: {$num_good}    {$LANG_MT2GEEKLOG[$LANG]['failure']}: {$num_bad}";
}

// Parses Movable Type DateTime format (MM/DD/YYYY HH:mm:ss OR MM/DD/YYYY hh:mm:ss (AM|PM)
// and covert it to Geeklog Format (YYYY-MM-DD HH:MM:SS).  If an error occurs, it will
// return '0000-00-00 00:00:00'.

function parseMTDateTime($str) {

    if ($str == '') {
        $dt = '0000-00-00 00:00:00';
    } else {
        $ut = strtotime($str);
        if ($ut === false || $ut == -1) {
            $dt = '0000-00-00 00:00:00';
        } else {
            $dt = date('Y-m-d H:i:s', $ut);
        }
    }
    
    return $dt;
}

// Extracts key and value from a string in the "key: value" format.  When the key is
// the DATE key, the value will be converted to Geeklog DateTime format
// 'YYYY-MM-DD hh:mm:ss'.
//
// @return (boolean) true -- $s has a key and a value.

function getKeyAndValue($s, $allowedkeys, &$key, &$val) {
    
    $p = strpos($s, ':');
    if ($p > 0) {
        $key = strtoupper(trim(substr($s, 0, $p)));
        if (in_array($key, $allowedkeys)) {
            $val = trim(substr($s, $p + 1));
            if ($key == 'DATE') {
                $val = parseMTDateTime($val);
            }
            return true;
        }
    }

    $key = $val = '';
    return false;
}

// Parses Movable Type META fields and returns an array

function parseMetadata($mt_meta, $META_KEYS) {
    $meta = array();
    $fields = explode(META_SEPARATOR, $mt_meta);
    foreach ($fields as $field) {
        if (getKeyAndValue($field, $META_KEYS, $key, $val)) {
            $meta[$key] = $val;
        }
    }

    return $meta;
}

// Returns a unique Story ID

function getUniquesid() {
    global $_TABLES;
    
    do {
        $sid = COM_makesid();
        $rst = DB_query("SELECT COUNT(*) FROM {$_TABLES['stories']} WHERE (sid = '$sid');");
        $A = DB_fetchArray($rst);
    } while ($A[0] != 0);
    
    return $sid;
}

// Gets a user ID from the author($author).  If no corresponding user is registered
// yet, a new account will be created when $op_author is 'au_astheyare'.  If
// $op_author is 'au_astheyare_possible', admin's user ID will be returned.
//
// NOTE: Even if a new account is created, admin won't be notified.

function getAuthorId($author, $op_author) {
    global $_TABLES, $_USER, $_CONF;
    
    if ($author == '') {
        return $_USER['uid'];
    }
    
    $author = addslashes($author);
    $rst = DB_query("SELECT uid FROM {$_TABLES['users']} WHERE (username = '$author');");
    if (DB_numRows($rst) > 0) {     // A corresponding user exists
        $A = DB_fetchArray($rst);
        return $A['uid'];
    }
    
    // No corresponding user exists
    if ($op_author == 'au_astheyare') {
        COM_errorLog("phpblock_mt2geeklog: Adding a user '$author' ...");
        if (defined('DEBUG')) {
            COM_errorLog("phpblock_mt2geeklog: (DEBUG) a user '$author' created.");
        } else {
            $email = COM_makesid() . '@example.com';  // Creates an Email address
            $old_notification = $_CONF['notification'];
            unset($_CONF['notification']);
            $uid = USER_createAccount (stripslashes($author), $email);
            $_CONF['notification'] = $old_notification;
            COM_errorLog("phpblock_mt2geeklog: a user '$author' created, awaitng login.");
        }
        return $uid;
    } else {
        return $_USER['uid'];   // in case $op_author is 'au_astheyare_possible'
    }
}

// Returns a proper Topic ID, considering Primary Category($pr_cat) and Category($cat).
// If there is no proper one, a topic designated in $op_default_category will be created.

function getTopicId($pr_cat, $cat, $op_default_category) {

    global $_TABLES, $_USER;
    
    if (! empty($pr_cat)) {
        $topic = $pr_cat;
    } else if (! empty($cat)) {
        $topic = $cat;
    } else {
        $topic = $op_default_category;
    }
    
    $tid   = md5($topic);           // This value is not used in the next DB q.uery
    $topic = addslashes($topic);
    $rst   = DB_query("SELECT tid FROM {$_TABLES['topics']} WHERE topic = '$topic';");
    if (DB_numRows($rst) == 1) {    // A proper topic is found.
        $A = DB_fetchArray($rst);
        return $A['tid'];
    }
    
    // Creates a new topic
    $imageurl   = '/images/topics/topic_gl.gif';
    $sortnum    = 0;
    $limitnews  = 10;
    $is_default = 0;
    $owner_id   = 2;    // Admin
    $group_id   = 6;    // Topic Admin

    if (defined('DEBUG')) {
        COM_errorLog("phpblock_mt2geeklog: (DEBUG) query = " . "INSERT INTO {$_TABLES['topics']} (tid, topic, imageurl, sortnum, limitnews, is_default, owner_id, group_id) VALUES ('$tid', '$topic', '$imageurl', $sortnum, $limitnews, $is_default, $owner_id, $group_id);");
    } else {
        DB_query("INSERT INTO {$_TABLES['topics']} (tid, topic, imageurl, sortnum, limitnews, is_default, owner_id, group_id) VALUES ('$tid', '$topic', '$imageurl', $sortnum, $limitnews, $is_default, $owner_id, $group_id);");
    }
    return $tid;
}

// Returns a part between {$op_start_title_html} and {$op_end_title_html} as a title.
// {$op_start_title_html} and {$op_end_title_html} will be treated as regular
// expressions.  See "mt2geeklog_xxxx.html" for detail.

function getTitleFromBody($body, $op_start_title_html, $op_end_title_html) {
    
    $pattern = "({$op_start_title_html})(.*)({$op_end_title_html})";
    if (eregi($pattern, $body, $match) === false) {
        return '';
    } else {
        return $match[2];
    }
}

// Returns BODY or EXTENDED BODY according to {$text_type}.  If {$text_type} is HTML,
// this functons will check with "story.edit" privilege (default).

function renderBody($body, $text_type, $cnv_br) {
    
    if ($text_type == 'plaintext') {
        $body = strip_tags($body);
    } else {
        $body = COM_checkHTML($body);
    }

    if ($cnv_br) {
        $body = str_replace(ML_SEPARATOR, BR_LINE, $body);
    } else {
        $body = str_replace(ML_SEPARATOR, '', $body);
    }
    
    return $body;
}

// Checks the validity of a given IP address.  Only IPv4 is supported.

function is_IPAddress($ip) {

    $ips = explode('.', $ip);
    if (count($ips) != 4) {
        return false;
    }
    
    for ($i = 0; $i < 4; $i ++) {
        if (! is_numeric($ips[$i])) {
            return false;
        }
        $v = intval($ips[$i]);
        if ($v < 0 || $v > 255) {
            return false;
        }
    }
    
    return true;
}

// Handles comments
//
// Comment Body will be processed as plaintext.

function do_comment($sid, $comment, $op_text_type, $cnv_br) {
    global $_TABLES;
    
    $type      = 'article';
    $date      = $comment['DATE'];
    $title     = 'NO TITLE';
    $comment   = strip_tags($comment['BODY']);
    if (! empty($comment['EMAIL']) && COM_isEmail($comment['EMAIL'])) {
        $comment .= ML_SEPARATOR . ML_SEPARATOR . 'Email: ' . $comment['EMAIL'];
    }
    $comment   = str_replace("\n", BR_LINE, $comment);
    $comment   = addslashes($comment);
    $uid       = 1; // anonymous user
    $ipaddress = $comment['IP'];
    if (! is_IPAddress($ipaddress)) {
        $ipaddress = '0.0.0.0';
    }
    
    if (defined('DEBUG')) {
        COM_errorLog("phpblock_mt2geeklog: (DEBUG) query = " . "INSERT INTO {$_TABLES['comments']} (type, sid, date, title, comment, uid, ipaddress) VALUES ('$type', '$sid', '$date', '$title', '$comment', $uid, '$ipaddress');");
    } else {
        DB_query("INSERT INTO {$_TABLES['comments']} (type, sid, date, title, comment, uid, ipaddress) VALUES ('$type', '$sid', '$date', '$title', '$comment', $uid, '$ipaddress');");
    }
    if (DB_error() == '') {
        return true;
    } else {
        return false;
    }
}

// Handles trackbacks
//
// Trackback body will be processed as plaintext.

function do_trackback($sid, $tb, $op_text_type, $cnv_br) {
    global $_TABLES;
    
    $url = strip_tags($tb['URL']);
    if (parse_url($url) === false) {
        $url = '';
    }
    $url       = addslashes($url);
    $title     = addslashes(strip_tags($tb['TITLE']));
    $blog      = addslashes(strip_tags($tb['BLOG NAME']));
    $excerpt   = str_replace("\n", BR_LINE, strip_tags($tb['BODY']));
    $excerpt   = addslashes($excerpt);
    $date      = $tb['DATE'];
    $type      = 'article';
    $ipaddress = $tb['IP'];
    if (! is_IPAddress($ipaddress)) {
        $ipaddress = '0.0.0.0';
    }

    if (defined('DEBUG')) {
        COM_errorLog("phpblock_mt2geeklog: (DEBUG) query = " . "INSERT INTO {$_TABLES['trackback']} (sid, url, title, blog, excerpt, date, type, ipaddress) VALUES ('$sid', '$url', '$title', '$blog', '$excerpt', '$date', '$type', '$ipaddress');");
    } else {
        DB_query("INSERT INTO {$_TABLES['trackback']} (sid, url, title, blog, excerpt, date, type, ipaddress) VALUES ('$sid', '$url', '$title', '$blog', '$excerpt', '$date', '$type', '$ipaddress');");
    }
    if (DB_error() == '') {
        return true;
    } else {
        return false;
    }
}

?>